# Create port_slicer
cell pavel-demin:user:port_slicer slice_0 {
  DIN_WIDTH 8 DIN_FROM 0 DIN_TO 0
}

# Create port_slicer
cell pavel-demin:user:port_slicer slice_3 {
  DIN_WIDTH 128 DIN_FROM 15 DIN_TO 0
}

for {set i 0} {$i <= 3} {incr i} {

  # Create port_slicer
  cell pavel-demin:user:port_slicer slice_[expr $i + 4] {
    DIN_WIDTH 128 DIN_FROM [expr $i + 16] DIN_TO [expr $i + 16]
  }

  # Create port_selector
  cell pavel-demin:user:port_selector selector_$i {
    DOUT_WIDTH 16
  } {
    cfg slice_[expr $i + 4]/dout
    din /adc_0/m_axis_tdata
  }

}

for {set i 0} {$i <= 1} {incr i} {

  # Create port_slicer
  cell pavel-demin:user:port_slicer slice_[expr $i + 1] {
    DIN_WIDTH 8 DIN_FROM $i DIN_TO $i
  }

  # Create port_slicer
  cell pavel-demin:user:port_slicer slice_[expr $i + 8] {
    DIN_WIDTH 128 DIN_FROM [expr 32 * $i + 63] DIN_TO [expr 32 * $i + 32]
  }

  # Create axis_constant
  cell pavel-demin:user:axis_constant phase_$i {
    AXIS_TDATA_WIDTH 32
  } {
    cfg_data slice_[expr $i + 8]/dout
    aclk /pll_0/clk_out1
  }

  # Create dds_compiler
  cell xilinx.com:ip:dds_compiler dds_$i {
    DDS_CLOCK_RATE 125
    SPURIOUS_FREE_DYNAMIC_RANGE 138
    FREQUENCY_RESOLUTION 0.2
    PHASE_INCREMENT Streaming
    HAS_ARESETN true
    HAS_PHASE_OUT false
    PHASE_WIDTH 30
    OUTPUT_WIDTH 24
    DSP48_USE Minimal
    NEGATIVE_SINE true
  } {
    S_AXIS_PHASE phase_$i/M_AXIS
    aclk /pll_0/clk_out1
    aresetn slice_[expr $i + 1]/dout
  }

}

# Create port_slicer
cell pavel-demin:user:port_slicer slice_10 {
  DIN_WIDTH 128 DIN_FROM 127 DIN_TO 96
}

# Create axis_constant
cell pavel-demin:user:axis_constant phase_2 {
  AXIS_TDATA_WIDTH 32
} {
  cfg_data slice_10/dout
  aclk /pll_0/clk_out1
}

# Create dds_compiler
cell xilinx.com:ip:dds_compiler dds_2 {
  DDS_CLOCK_RATE 125
  SPURIOUS_FREE_DYNAMIC_RANGE 138
  FREQUENCY_RESOLUTION 0.2
  PHASE_INCREMENT Streaming
  HAS_PHASE_OUT false
  PHASE_WIDTH 30
  OUTPUT_WIDTH 24
  DSP48_USE Minimal
  NEGATIVE_SINE true
} {
  S_AXIS_PHASE phase_2/M_AXIS
  aclk /pll_0/clk_out1
}

for {set i 0} {$i <= 5} {incr i} {

  # Create port_slicer
  cell pavel-demin:user:port_slicer dds_slice_$i {
    DIN_WIDTH 48 DIN_FROM [expr 24 * ($i % 2) + 23] DIN_TO [expr 24 * ($i % 2)]
  } {
    din dds_[expr $i / 2]/m_axis_data_tdata
  }

}

for {set i 0} {$i <= 3} {incr i} {

  # Create port_slicer
  cell pavel-demin:user:port_slicer dds_slice_[expr $i + 6] {
    DIN_WIDTH 48 DIN_FROM [expr 47 - 24 * ($i % 2)] DIN_TO [expr 24 - 24 * ($i % 2)]
  }

}

for {set i 0} {$i <= 7} {incr i} {

  # Create port_slicer
  cell pavel-demin:user:port_slicer adc_slice_$i {
    DIN_WIDTH 16 DIN_FROM 15 DIN_TO 0
  } {
    din selector_[expr $i / 2]/dout
  }

}

for {set i 0} {$i <= 1} {incr i} {

  # Create port_slicer
  cell pavel-demin:user:port_slicer adc_slice_[expr $i + 8] {
    DIN_WIDTH 16 DIN_FROM 13 DIN_TO 0
  }

}

# Create axis_lfsr
cell pavel-demin:user:axis_lfsr lfsr_0 {} {
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create xlconstant
cell xilinx.com:ip:xlconstant const_0

for {set i 0} {$i <= 9} {incr i} {

  # Create dsp_macro
  cell xilinx.com:ip:dsp_macro mult_$i {
    INSTRUCTION1 RNDSIMPLE(A*B+CARRYIN)
    A_WIDTH.VALUE_SRC USER
    B_WIDTH.VALUE_SRC USER
    OUTPUT_PROPERTIES User_Defined
    A_WIDTH 24
    B_WIDTH 14
    P_WIDTH 25
  } {
    A dds_slice_$i/dout
    B adc_slice_$i/dout
    CARRYIN lfsr_0/m_axis_tdata
    CLK /pll_0/clk_out1
  }

  # Create axis_variable
  cell pavel-demin:user:axis_variable rate_$i {
    AXIS_TDATA_WIDTH 16
  } {
    cfg_data slice_3/dout
    aclk /pll_0/clk_out1
    aresetn /rst_0/peripheral_aresetn
  }

  # Create cic_compiler
  cell xilinx.com:ip:cic_compiler cic_$i {
    INPUT_DATA_WIDTH.VALUE_SRC USER
    FILTER_TYPE Decimation
    NUMBER_OF_STAGES 6
    SAMPLE_RATE_CHANGES Programmable
    MINIMUM_RATE 125
    MAXIMUM_RATE 1000
    FIXED_OR_INITIAL_RATE 500
    INPUT_SAMPLE_FREQUENCY 125
    CLOCK_FREQUENCY 125
    INPUT_DATA_WIDTH 24
    QUANTIZATION Truncation
    OUTPUT_DATA_WIDTH 32
    USE_XTREME_DSP_SLICE false
    HAS_ARESETN true
  } {
    s_axis_data_tdata mult_$i/P
    s_axis_data_tvalid const_0/dout
    S_AXIS_CONFIG rate_$i/M_AXIS
    aclk /pll_0/clk_out1
    aresetn /rst_0/peripheral_aresetn
  }

}

# Create axis_combiner
cell  xilinx.com:ip:axis_combiner comb_0 {
  TDATA_NUM_BYTES.VALUE_SRC USER
  TDATA_NUM_BYTES 4
  NUM_SI 10
} {
  S00_AXIS cic_0/M_AXIS_DATA
  S01_AXIS cic_1/M_AXIS_DATA
  S02_AXIS cic_2/M_AXIS_DATA
  S03_AXIS cic_3/M_AXIS_DATA
  S04_AXIS cic_4/M_AXIS_DATA
  S05_AXIS cic_5/M_AXIS_DATA
  S06_AXIS cic_6/M_AXIS_DATA
  S07_AXIS cic_7/M_AXIS_DATA
  S08_AXIS cic_8/M_AXIS_DATA
  S09_AXIS cic_9/M_AXIS_DATA
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create axis_dwidth_converter
cell xilinx.com:ip:axis_dwidth_converter conv_0 {
  S_TDATA_NUM_BYTES.VALUE_SRC USER
  S_TDATA_NUM_BYTES 40
  M_TDATA_NUM_BYTES 4
} {
  S_AXIS comb_0/M_AXIS
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create fir_compiler
cell xilinx.com:ip:fir_compiler fir_0 {
  DATA_WIDTH.VALUE_SRC USER
  DATA_WIDTH 32
  COEFFICIENTVECTOR {1.1961249863e-08, 1.2656113242e-08, 1.3309358908e-08, 1.3941034466e-08, 1.4577284871e-08, 1.5250466447e-08, 1.5999126380e-08, 1.6867833605e-08, 1.7906848440e-08, 1.9171620108e-08, 2.0722103492e-08, 2.2621888930e-08, 2.4937141679e-08, 2.7735350818e-08, 3.1083890736e-08, 3.5048401979e-08, 3.9691002072e-08, 4.5068340863e-08, 5.1229519040e-08, 5.8213892520e-08, 6.6048789471e-08, 7.4747170707e-08, 8.4305267918e-08, 9.4700237761e-08, 1.0588787301e-07, 1.1780041475e-07, 1.3034451197e-07, 1.4339937649e-07, 1.5681518263e-07, 1.7041176103e-07, 1.8397763614e-07, 1.9726945559e-07, 2.1001185770e-07, 2.2189782077e-07, 2.3258953374e-07, 2.4171982374e-07, 2.4889416998e-07, 2.5369332733e-07, 2.5567657596e-07, 2.5438560470e-07, 2.4934902788e-07, 2.4008752517e-07, 2.2611958469e-07, 2.0696781862e-07, 1.8216581031e-07, 1.5126544051e-07, 1.1384462961e-07, 6.9515421839e-08, 1.7932326771e-08, -4.1199176753e-08, -1.0811407849e-07, -1.8297932947e-07, -2.6588551026e-07, -3.5683880180e-07, -4.5575339146e-07, -5.6244445003e-07, -6.7662181787e-07, -7.9788453816e-07, -9.2571637381e-07, -1.0594824405e-06, -1.1984270824e-06, -1.3416731099e-06, -1.4882225061e-06, -1.6369586998e-06, -1.7866504848e-06, -1.9359576509e-06, -2.0834383713e-06, -2.2275583733e-06, -2.3667018929e-06, -2.4991843954e-06, -2.6232670130e-06, -2.7371726299e-06, -2.8391035153e-06, -2.9272603793e-06, -2.9998626976e-06, -3.0551701281e-06, -3.0915048107e-06, -3.1072743236e-06, -3.1009950394e-06, -3.0713156082e-06, -3.0170402731e-06, -2.9371517077e-06, -2.8308330538e-06, -2.6974888247e-06, -2.5367643381e-06, -2.3485633372e-06, -2.1330634646e-06, -1.8907292580e-06, -1.6223223537e-06, -1.3289085964e-06, -1.0118617792e-06, -6.7286376522e-07, -3.1390077269e-07, 6.2744355816e-08, 4.5450403794e-07, 8.5854208223e-07, 1.2717741070e-06, 1.6908922361e-06, 2.1123940033e-06, 2.5326153400e-06, 2.9477674568e-06, 3.3539773725e-06, 3.7473317769e-06, 4.1239238569e-06, 4.4799026514e-06, 4.8115244440e-06, 5.1152056481e-06, 5.3875765849e-06, 5.6255355116e-06, 5.8263022146e-06, 5.9874704478e-06, 6.1070584697e-06, 6.1835569145e-06, 6.2159732223e-06, 6.2038718500e-06, 6.1474094983e-06, 6.0473646055e-06, 5.9051603899e-06, 5.7228807660e-06, 5.5032785074e-06, 5.2497750941e-06, 4.9664517572e-06, 4.6580313120e-06, 4.3298504706e-06, 3.9878224217e-06, 3.6383895800e-06, 3.2884665245e-06, 2.9453732684e-06, 2.6167591349e-06, 2.3105176459e-06, 2.0346929637e-06, 1.7973785676e-06, 1.6066089745e-06, 1.4702454549e-06, 1.3958568136e-06, 1.3905964346e-06, 1.4610768981e-06, 1.6132435831e-06, 1.8522487606e-06, 2.1823277608e-06, 2.6066788603e-06, 3.1273485830e-06, 3.7451241349e-06, 4.4594347041e-06, 5.2682633429e-06, 6.1680711188e-06, 7.1537351635e-06, 8.2185021735e-06, 9.3539588131e-06, 1.0550020349e-05, 1.1794938703e-05, 1.3075330929e-05, 1.4376228960e-05, 1.5681151229e-05, 1.6972196563e-05, 1.8230160516e-05, 1.9434674022e-05, 2.0564364005e-05, 2.1597035305e-05, 2.2509872977e-05, 2.3279663760e-05, 2.3883035203e-05, 2.4296710670e-05, 2.4497778154e-05, 2.4463970577e-05, 2.4173954994e-05, 2.3607627882e-05, 2.2746413501e-05, 2.1573562086e-05, 2.0074444524e-05, 1.8236839983e-05, 1.6051212914e-05, 1.3510975758e-05, 1.0612733686e-05, 7.3565077152e-06, 3.7459326243e-06, -2.1157381935e-07, -4.5046736336e-06, -9.1180065209e-06, -1.4032125765e-05, -1.9223474710e-05, -2.4664406079e-05, -3.0323245996e-05, -3.6164404192e-05, -4.2148531408e-05, -4.8232724519e-05, -5.4370779428e-05, -6.0513491209e-05, -6.6609000452e-05, -7.2603184194e-05, -7.8440089244e-05, -8.4062405141e-05, -8.9411973420e-05, -9.4430329303e-05, -9.9059271400e-05, -1.0324145449e-04, -1.0692099996e-04, -1.1004411813e-04, -1.1255973607e-04, -1.1442012455e-04, -1.1558151707e-04, -1.1600471401e-04, -1.1565566460e-04, -1.1450601950e-04, -1.1253364661e-04, -1.0972310293e-04, -1.0606605545e-04, -1.0156164422e-04, -9.6216781265e-05, -9.0046379131e-05, -8.3073503774e-05, -7.5329446693e-05, -6.6853712149e-05, -5.7693915960e-05, -4.7905593178e-05, -3.7551912876e-05, -2.6703299179e-05, -1.5436958696e-05, -3.8363155200e-06, 8.0096439618e-06, 2.0007113125e-05, 3.2058289607e-05, 4.4062276739e-05, 5.5916055311e-05, 6.7515518031e-05, 7.8756558001e-05, 8.9536201588e-05, 9.9753775155e-05, 1.0931209429e-04, 1.1811866343e-04, 1.2608687319e-04, 1.3313718199e-04, 1.3919826855e-04, 1.4420814098e-04, 1.4811518866e-04, 1.5087916265e-04, 1.5247207066e-04, 1.5287897311e-04, 1.5209866690e-04, 1.5014424456e-04, 1.4704351683e-04, 1.4283928797e-04, 1.3758947409e-04, 1.3136705595e-04, 1.2425985922e-04, 1.1637015654e-04, 1.0781408765e-04, 9.8720895165e-05, 8.9231975840e-05, 7.9499748934e-05, 6.9686345180e-05, 5.9962122071e-05, 5.0504013152e-05, 4.1493721099e-05, 3.3115766424e-05, 2.5555405684e-05, 1.8996435016e-05, 1.3618896743e-05, 9.5967085478e-06, 7.0952364049e-06, 6.2688339697e-06, 7.2583724812e-06, 1.0188786407e-05, 1.5166661028e-05, 2.2277888902e-05, 3.1585422675e-05, 4.3127151932e-05, 5.6913931836e-05, 7.2927790966e-05, 9.1120345272e-05, 1.1141144420e-04, 1.3368807394e-04, 1.5780354126e-04, 1.8357695995e-04, 2.1079305951e-04, 2.3920233403e-04, 2.6852154618e-04, 2.9843459894e-04, 3.2859378451e-04, 3.5862141681e-04, 3.8811185051e-04, 4.1663388634e-04, 4.4373355840e-04, 4.6893729598e-04, 4.9175544814e-04, 5.1168615591e-04, 5.2821955296e-04, 5.4084227183e-04, 5.4904222921e-04, 5.5231366012e-04, 5.5016236740e-04, 5.4211114982e-04, 5.2770536879e-04, 5.0651861114e-04, 4.7815840291e-04, 4.4227192668e-04, 3.9855169348e-04, 3.4674111860e-04, 2.8663994967e-04, 2.1810949466e-04, 1.4107759738e-04, 5.5543308130e-05, -3.8418802029e-05, -1.4065473376e-04, -2.5092760749e-04, -3.6891471354e-04, -4.9420510855e-04, -6.2629779903e-04, -7.6460054973e-04, -9.0842935040e-04, -1.0570085703e-03, -1.2094718251e-03, -1.3648635759e-03, -1.5221414746e-03, -1.6801794646e-03, -1.8377716396e-03, -1.9936368570e-03, -2.1464240976e-03, -2.2947185558e-03, -2.4370484378e-03, -2.5718924414e-03, -2.6976878815e-03, -2.8128394227e-03, -2.9157283720e-03, -3.0047224798e-03, -3.0781861930e-03, -3.1344912968e-03, -3.1720278797e-03, -3.1892155494e-03, -3.1845148258e-03, -3.1564386330e-03, -3.1035638088e-03, -3.0245425496e-03, -2.9181137071e-03, -2.7831138490e-03, -2.6184880023e-03, -2.4232999904e-03, -2.1967422833e-03, -1.9381452771e-03, -1.6469859243e-03, -1.3228956388e-03, -9.6566740211e-04, -5.7526200496e-04, -1.5181335882e-04, 3.0436717758e-04, 7.9278750903e-04, 1.3127725959e-03, 1.8634633643e-03, 2.4438167652e-03, 3.0526070025e-03, 3.6884279453e-03, 4.3496967289e-03, 5.0346585412e-03, 5.7413925826e-03, 6.4678191796e-03, 7.2117080210e-03, 7.9706874816e-03, 8.7422549845e-03, 9.5237883505e-03, 1.0312558071e-02, 1.1105740435e-02, 1.1900431436e-02, 1.2693661374e-02, 1.3482410066e-02, 1.4263622567e-02, 1.5034225309e-02, 1.5791142555e-02, 1.6531313053e-02, 1.7251706798e-02, 1.7949341779e-02, 1.8621300604e-02, 1.9264746903e-02, 1.9876941379e-02, 2.0455257419e-02, 2.0997196151e-02, 2.1500400838e-02, 2.1962670528e-02, 2.2381972851e-02, 2.2756455881e-02, 2.3084458983e-02, 2.3364522569e-02, 2.3595396690e-02, 2.3776048416e-02, 2.3905667942e-02, 2.3983673382e-02, 2.4009714219e-02, 2.3983673382e-02, 2.3905667942e-02, 2.3776048416e-02, 2.3595396690e-02, 2.3364522569e-02, 2.3084458983e-02, 2.2756455881e-02, 2.2381972851e-02, 2.1962670528e-02, 2.1500400838e-02, 2.0997196151e-02, 2.0455257419e-02, 1.9876941379e-02, 1.9264746903e-02, 1.8621300604e-02, 1.7949341779e-02, 1.7251706798e-02, 1.6531313053e-02, 1.5791142555e-02, 1.5034225309e-02, 1.4263622567e-02, 1.3482410066e-02, 1.2693661374e-02, 1.1900431436e-02, 1.1105740435e-02, 1.0312558071e-02, 9.5237883505e-03, 8.7422549845e-03, 7.9706874816e-03, 7.2117080210e-03, 6.4678191796e-03, 5.7413925826e-03, 5.0346585412e-03, 4.3496967289e-03, 3.6884279453e-03, 3.0526070025e-03, 2.4438167652e-03, 1.8634633643e-03, 1.3127725959e-03, 7.9278750903e-04, 3.0436717758e-04, -1.5181335882e-04, -5.7526200496e-04, -9.6566740211e-04, -1.3228956388e-03, -1.6469859243e-03, -1.9381452771e-03, -2.1967422833e-03, -2.4232999904e-03, -2.6184880023e-03, -2.7831138490e-03, -2.9181137071e-03, -3.0245425496e-03, -3.1035638088e-03, -3.1564386330e-03, -3.1845148258e-03, -3.1892155494e-03, -3.1720278797e-03, -3.1344912968e-03, -3.0781861930e-03, -3.0047224798e-03, -2.9157283720e-03, -2.8128394227e-03, -2.6976878815e-03, -2.5718924414e-03, -2.4370484378e-03, -2.2947185558e-03, -2.1464240976e-03, -1.9936368570e-03, -1.8377716396e-03, -1.6801794646e-03, -1.5221414746e-03, -1.3648635759e-03, -1.2094718251e-03, -1.0570085703e-03, -9.0842935040e-04, -7.6460054973e-04, -6.2629779903e-04, -4.9420510855e-04, -3.6891471354e-04, -2.5092760749e-04, -1.4065473376e-04, -3.8418802029e-05, 5.5543308130e-05, 1.4107759738e-04, 2.1810949466e-04, 2.8663994967e-04, 3.4674111860e-04, 3.9855169348e-04, 4.4227192668e-04, 4.7815840291e-04, 5.0651861114e-04, 5.2770536879e-04, 5.4211114982e-04, 5.5016236740e-04, 5.5231366012e-04, 5.4904222921e-04, 5.4084227183e-04, 5.2821955296e-04, 5.1168615591e-04, 4.9175544814e-04, 4.6893729598e-04, 4.4373355840e-04, 4.1663388634e-04, 3.8811185051e-04, 3.5862141681e-04, 3.2859378451e-04, 2.9843459894e-04, 2.6852154618e-04, 2.3920233403e-04, 2.1079305951e-04, 1.8357695995e-04, 1.5780354126e-04, 1.3368807394e-04, 1.1141144420e-04, 9.1120345272e-05, 7.2927790966e-05, 5.6913931836e-05, 4.3127151932e-05, 3.1585422675e-05, 2.2277888902e-05, 1.5166661028e-05, 1.0188786407e-05, 7.2583724812e-06, 6.2688339697e-06, 7.0952364049e-06, 9.5967085478e-06, 1.3618896743e-05, 1.8996435016e-05, 2.5555405684e-05, 3.3115766424e-05, 4.1493721099e-05, 5.0504013152e-05, 5.9962122071e-05, 6.9686345180e-05, 7.9499748934e-05, 8.9231975840e-05, 9.8720895165e-05, 1.0781408765e-04, 1.1637015654e-04, 1.2425985922e-04, 1.3136705595e-04, 1.3758947409e-04, 1.4283928797e-04, 1.4704351683e-04, 1.5014424456e-04, 1.5209866690e-04, 1.5287897311e-04, 1.5247207066e-04, 1.5087916265e-04, 1.4811518866e-04, 1.4420814098e-04, 1.3919826855e-04, 1.3313718199e-04, 1.2608687319e-04, 1.1811866343e-04, 1.0931209429e-04, 9.9753775155e-05, 8.9536201588e-05, 7.8756558001e-05, 6.7515518031e-05, 5.5916055311e-05, 4.4062276739e-05, 3.2058289607e-05, 2.0007113125e-05, 8.0096439618e-06, -3.8363155200e-06, -1.5436958696e-05, -2.6703299179e-05, -3.7551912876e-05, -4.7905593178e-05, -5.7693915960e-05, -6.6853712149e-05, -7.5329446693e-05, -8.3073503774e-05, -9.0046379131e-05, -9.6216781265e-05, -1.0156164422e-04, -1.0606605545e-04, -1.0972310293e-04, -1.1253364661e-04, -1.1450601950e-04, -1.1565566460e-04, -1.1600471401e-04, -1.1558151707e-04, -1.1442012455e-04, -1.1255973607e-04, -1.1004411813e-04, -1.0692099996e-04, -1.0324145449e-04, -9.9059271400e-05, -9.4430329303e-05, -8.9411973420e-05, -8.4062405141e-05, -7.8440089244e-05, -7.2603184194e-05, -6.6609000452e-05, -6.0513491209e-05, -5.4370779428e-05, -4.8232724519e-05, -4.2148531408e-05, -3.6164404192e-05, -3.0323245996e-05, -2.4664406079e-05, -1.9223474710e-05, -1.4032125765e-05, -9.1180065209e-06, -4.5046736336e-06, -2.1157381935e-07, 3.7459326243e-06, 7.3565077152e-06, 1.0612733686e-05, 1.3510975758e-05, 1.6051212914e-05, 1.8236839983e-05, 2.0074444524e-05, 2.1573562086e-05, 2.2746413501e-05, 2.3607627882e-05, 2.4173954994e-05, 2.4463970577e-05, 2.4497778154e-05, 2.4296710670e-05, 2.3883035203e-05, 2.3279663760e-05, 2.2509872977e-05, 2.1597035305e-05, 2.0564364005e-05, 1.9434674022e-05, 1.8230160516e-05, 1.6972196563e-05, 1.5681151229e-05, 1.4376228960e-05, 1.3075330929e-05, 1.1794938703e-05, 1.0550020349e-05, 9.3539588131e-06, 8.2185021735e-06, 7.1537351635e-06, 6.1680711188e-06, 5.2682633429e-06, 4.4594347041e-06, 3.7451241349e-06, 3.1273485830e-06, 2.6066788603e-06, 2.1823277608e-06, 1.8522487606e-06, 1.6132435831e-06, 1.4610768981e-06, 1.3905964346e-06, 1.3958568136e-06, 1.4702454549e-06, 1.6066089745e-06, 1.7973785676e-06, 2.0346929637e-06, 2.3105176459e-06, 2.6167591349e-06, 2.9453732684e-06, 3.2884665245e-06, 3.6383895800e-06, 3.9878224217e-06, 4.3298504706e-06, 4.6580313120e-06, 4.9664517572e-06, 5.2497750941e-06, 5.5032785074e-06, 5.7228807660e-06, 5.9051603899e-06, 6.0473646055e-06, 6.1474094983e-06, 6.2038718500e-06, 6.2159732223e-06, 6.1835569145e-06, 6.1070584697e-06, 5.9874704478e-06, 5.8263022146e-06, 5.6255355116e-06, 5.3875765849e-06, 5.1152056481e-06, 4.8115244440e-06, 4.4799026514e-06, 4.1239238569e-06, 3.7473317769e-06, 3.3539773725e-06, 2.9477674568e-06, 2.5326153400e-06, 2.1123940033e-06, 1.6908922361e-06, 1.2717741070e-06, 8.5854208223e-07, 4.5450403794e-07, 6.2744355816e-08, -3.1390077269e-07, -6.7286376522e-07, -1.0118617792e-06, -1.3289085964e-06, -1.6223223537e-06, -1.8907292580e-06, -2.1330634646e-06, -2.3485633372e-06, -2.5367643381e-06, -2.6974888247e-06, -2.8308330538e-06, -2.9371517077e-06, -3.0170402731e-06, -3.0713156082e-06, -3.1009950394e-06, -3.1072743236e-06, -3.0915048107e-06, -3.0551701281e-06, -2.9998626976e-06, -2.9272603793e-06, -2.8391035153e-06, -2.7371726299e-06, -2.6232670130e-06, -2.4991843954e-06, -2.3667018929e-06, -2.2275583733e-06, -2.0834383713e-06, -1.9359576509e-06, -1.7866504848e-06, -1.6369586998e-06, -1.4882225061e-06, -1.3416731099e-06, -1.1984270824e-06, -1.0594824405e-06, -9.2571637381e-07, -7.9788453816e-07, -6.7662181787e-07, -5.6244445003e-07, -4.5575339146e-07, -3.5683880180e-07, -2.6588551026e-07, -1.8297932947e-07, -1.0811407849e-07, -4.1199176753e-08, 1.7932326771e-08, 6.9515421839e-08, 1.1384462961e-07, 1.5126544051e-07, 1.8216581031e-07, 2.0696781862e-07, 2.2611958469e-07, 2.4008752517e-07, 2.4934902788e-07, 2.5438560470e-07, 2.5567657596e-07, 2.5369332733e-07, 2.4889416998e-07, 2.4171982374e-07, 2.3258953374e-07, 2.2189782077e-07, 2.1001185770e-07, 1.9726945559e-07, 1.8397763614e-07, 1.7041176103e-07, 1.5681518263e-07, 1.4339937649e-07, 1.3034451197e-07, 1.1780041475e-07, 1.0588787301e-07, 9.4700237761e-08, 8.4305267918e-08, 7.4747170707e-08, 6.6048789471e-08, 5.8213892520e-08, 5.1229519040e-08, 4.5068340863e-08, 3.9691002072e-08, 3.5048401979e-08, 3.1083890736e-08, 2.7735350818e-08, 2.4937141679e-08, 2.2621888930e-08, 2.0722103492e-08, 1.9171620108e-08, 1.7906848440e-08, 1.6867833605e-08, 1.5999126380e-08, 1.5250466447e-08, 1.4577284871e-08, 1.3941034466e-08, 1.3309358908e-08, 1.2656113242e-08, 1.1961249863e-08}
  COEFFICIENT_WIDTH 24
  QUANTIZATION Quantize_Only
  BESTPRECISION true
  FILTER_TYPE Decimation
  RATE_CHANGE_TYPE Fixed_Fractional
  INTERPOLATION_RATE 24
  DECIMATION_RATE 25
  NUMBER_CHANNELS 10
  NUMBER_PATHS 1
  SAMPLE_FREQUENCY 1.0
  CLOCK_FREQUENCY 125
  OUTPUT_ROUNDING_MODE Convergent_Rounding_to_Even
  OUTPUT_WIDTH 25
  HAS_ARESETN true
} {
  S_AXIS_DATA conv_0/M_AXIS
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create axis_subset_converter
cell xilinx.com:ip:axis_subset_converter subset_0 {
  S_TDATA_NUM_BYTES.VALUE_SRC USER
  M_TDATA_NUM_BYTES.VALUE_SRC USER
  S_TDATA_NUM_BYTES 4
  M_TDATA_NUM_BYTES 3
  TDATA_REMAP {tdata[23:0]}
} {
  S_AXIS fir_0/M_AXIS_DATA
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create fir_compiler
cell xilinx.com:ip:fir_compiler fir_1 {
  DATA_WIDTH.VALUE_SRC USER
  DATA_WIDTH 24
  COEFFICIENTVECTOR {3.1508923780e-09, -6.7475980529e-09, -1.6132735183e-08, -2.2415579506e-08, -2.3717263238e-08, -1.9291397469e-08, -9.6168631043e-09, 3.7552961640e-09, 1.8453365232e-08, 3.1533102468e-08, 3.9743046382e-08, 3.9941387186e-08, 2.9810086399e-08, 8.8709780392e-09, -2.0449868854e-08, -5.2218186890e-08, -7.7444947193e-08, -8.5988254939e-08, -6.9781196307e-08, -2.6584466614e-08, 3.7107600426e-08, 1.0553097155e-07, 1.5653344067e-07, 1.6783322885e-07, 1.2520716088e-07, 2.9948747913e-08, -9.7515708891e-08, -2.2027045215e-07, -2.9438682451e-07, -2.8328423750e-07, -1.7267928231e-07, 1.9373805322e-08, 2.4218019730e-07, 4.2400013810e-07, 4.9366408311e-07, 4.0620040085e-07, 1.6381629332e-07, -1.7632038325e-07, -5.1272445024e-07, -7.2802669830e-07, -7.2792645896e-07, -4.7832916024e-07, -2.6981442896e-08, 5.0063327475e-07, 9.3364621512e-07, 1.1090895675e-06, 9.3018257513e-07, 4.0957853952e-07, -3.1991371086e-07, -1.0354128881e-06, -1.4896978510e-06, -1.4940634948e-06, -9.9129109401e-07, -9.1803601172e-08, 9.4424053349e-07, 1.7791644058e-06, 2.1054324474e-06, 1.7552123092e-06, 7.7380244447e-07, -5.7268564088e-07, -1.8652140243e-06, -2.6597204012e-06, -2.6368887506e-06, -1.7240919308e-06, -1.4449612556e-07, 1.6307876012e-06, 3.0202691103e-06, 3.5203155568e-06, 2.8838382349e-06, 1.2270585108e-06, -9.7868476333e-07, -3.0371590435e-06, -4.2450709099e-06, -4.1300403642e-06, -2.6288424402e-06, -1.4025014667e-07, 2.5751940256e-06, 4.6257089238e-06, 5.2799799527e-06, 4.2249763239e-06, 1.6997409781e-06, -1.5487428351e-06, -4.4843071471e-06, -6.1118513367e-06, -5.8139546172e-06, -3.5801046005e-06, -4.4603515125e-08, 3.6905215070e-06, 6.3994942325e-06, 7.1362377761e-06, 5.5640850802e-06, 2.0968587868e-06, -2.2051754159e-06, -5.9605420071e-06, -7.9130606737e-06, -7.3543987654e-06, -4.3796369526e-06, 1.1626773176e-07, 4.7090628686e-06, 7.9008498602e-06, 8.6136867262e-06, 6.5567645209e-06, 2.3408079704e-06, -2.7046697321e-06, -6.9564940688e-06, -9.0277243520e-06, -8.2268354832e-06, -4.7917163972e-06, 1.8217550581e-07, 5.0979536375e-06, 8.3801851737e-06, 8.9901647048e-06, 6.7614694683e-06, 2.4445858312e-06, -2.5517907362e-06, -6.6324875594e-06, -8.5392432322e-06, -7.7493817632e-06, -4.6192713319e-06, -2.3216577300e-07, 3.9877755478e-06, 6.7553186521e-06, 7.3308520516e-06, 5.7195376433e-06, 2.6074563892e-06, -9.2519518420e-07, -3.7970209232e-06, -5.2771879357e-06, -5.1743746584e-06, -3.8111480273e-06, -1.8177664888e-06, 1.5304131717e-07, 1.6657000897e-06, 2.6007005635e-06, 3.0863715053e-06, 3.3152620119e-06, 3.3505665573e-06, 3.0329617641e-06, 2.0504996242e-06, 1.5284471504e-07, -2.5887090163e-06, -5.6151292979e-06, -7.9261174173e-06, -8.3764326573e-06, -6.1462001935e-06, -1.2105987638e-06, 5.4040281514e-06, 1.1742225476e-05, 1.5455920723e-05, 1.4624666152e-05, 8.5865507701e-06, -1.5488302566e-06, -1.2966644463e-05, -2.1871564461e-05, -2.4708140103e-05, -1.9497674077e-05, -6.8093663060e-06, 1.0051135135e-05, 2.5820777277e-05, 3.4877895713e-05, 3.3190865626e-05, 1.9956820947e-05, -1.7005409523e-06, -2.5341999448e-05, -4.3072443236e-05, -4.8132991516e-05, -3.7388549018e-05, -1.2818473965e-05, 1.8623490804e-05, 4.6902107727e-05, 6.2061100756e-05, 5.7670458115e-05, 3.3383490018e-05, -4.3727841506e-06, -4.3987115894e-05, -7.2187135903e-05, -7.8444696389e-05, -5.8813990893e-05, -1.7827740761e-05, 3.2362851966e-05, 7.5529429710e-05, 9.6580616528e-05, 8.6784841751e-05, 4.7209254540e-05, -1.0935391065e-05, -6.9383750458e-05, -1.0852240285e-04, -1.1394262823e-04, -8.1658719488e-05, -2.0124688423e-05, 5.1842263438e-05, 1.1077980801e-04, 1.3621687768e-04, 1.1774721572e-04, 5.9105543949e-05, -2.2306275728e-05, -1.0053359641e-04, -1.4934104286e-04, -1.5100771436e-04, -1.0269720775e-04, -1.8128764758e-05, 7.6242050704e-05, 1.4950179648e-04, 1.7642744971e-04, 1.4616599009e-04, 6.6457824879e-05, -3.8203309458e-05, -1.3409848281e-04, -1.8918857601e-04, -1.8385675841e-04, -1.1787316761e-04, -1.1111785679e-05, 1.0242917673e-04, 1.8551074068e-04, 2.0994002924e-04, 1.6618260399e-04, 6.7005785027e-05, -5.6222882892e-05, -1.6352298110e-04, -2.1937624177e-04, -2.0458062132e-04, -1.2289402382e-04, -1.5101419225e-07, 1.2397675727e-04, 2.0893139699e-04, 2.2666418994e-04, 1.7100416652e-04, 5.9831203220e-05, -7.0726777909e-05, -1.7817793102e-04, -2.2768183234e-04, -2.0351432116e-04, -1.1415035601e-04, 1.0716214384e-05, 1.3017577907e-04, 2.0572509741e-04, 2.1390660336e-04, 1.5373856266e-04, 4.6523331080e-05, -7.1759757623e-05, -1.6275453558e-04, -1.9845476965e-04, -1.7004225236e-04, -8.9963237964e-05, 1.3223467640e-05, 1.0518393539e-04, 1.5756235637e-04, 1.5703069703e-04, 1.0863530804e-04, 3.2592474737e-05, -4.3936548271e-05, -9.6827810123e-05, -1.1300386613e-04, -9.3676570509e-05, -5.1981141056e-05, -6.3555110073e-06, 2.7392441069e-05, 4.2016087646e-05, 4.0421677825e-05, 3.2499933259e-05, 2.8850898049e-05, 3.4425412471e-05, 4.5182821672e-05, 4.9573991470e-05, 3.4495688585e-05, -6.7874565391e-06, -6.8459660036e-05, -1.3107017988e-04, -1.6702097766e-04, -1.5132051136e-04, -7.3723222352e-05, 5.2880144342e-05, 1.9219801126e-04, 2.9406336570e-04, 3.1160952577e-04, 2.2046888593e-04, 3.2644505134e-05, -2.0133116207e-04, -4.0471101887e-04, -4.9886785744e-04, -4.3220955008e-04, -2.0342762459e-04, 1.3045184710e-04, 4.6633925499e-04, 6.8590911345e-04, 6.9612599813e-04, 4.6592713429e-04, 4.5258358757e-05, -4.4257906414e-04, -8.3570979460e-04, -9.8629867812e-04, -8.1424765891e-04, -3.4298680990e-04, 2.9729829935e-04, 9.0363849988e-04, 1.2633824175e-03, 1.2272322070e-03, 7.6758402569e-04, 2.7737342414e-07, -8.4142966492e-04, -1.4761811173e-03, -1.6671073846e-03, -1.3076663513e-03, -4.7033833337e-04, 6.0205742619e-04, 1.5645443794e-03, 2.0793590882e-03, 1.9323656242e-03, 1.1170156172e-03, -1.4578448117e-04, -1.4640955099e-03, -2.3946074558e-03, -2.5896898166e-03, -1.9236804537e-03, -5.5353327163e-04, 1.1121209355e-03, 2.5321379468e-03, 3.2064623625e-03, 2.8491878898e-03, 1.5020813220e-03, -4.5459597422e-04, -2.4053977998e-03, -3.6905740791e-03, -3.8262174170e-03, -2.6811344710e-03, -5.4728612220e-04, 1.9278490532e-03, 3.9341201552e-03, 4.7605559337e-03, 4.0426404274e-03, 1.9103978174e-03, -1.0198178937e-03, -3.8181942717e-03, -5.5323829037e-03, -5.5067729307e-03, -3.6245610468e-03, -3.8565799356e-04, 3.2173803305e-03, 5.9979433577e-03, 6.9604662490e-03, 5.6488257898e-03, 2.3385037355e-03, -2.0030177737e-03, -5.9908381328e-03, -8.2569924426e-03, -7.9106390313e-03, -4.8720251529e-03, 4.0504695980e-05, 5.3174655311e-03, 9.2116081137e-03, 1.0304733302e-02, 8.0075913727e-03, 2.8215289899e-03, -3.7430904239e-03, -9.5908218100e-03, -1.2693294804e-02, -1.1771468561e-02, -6.7847762229e-03, 9.4980454205e-04, 9.0780941430e-03, 1.4899387766e-02, 1.6231860270e-02, 1.2184272007e-02, 3.5738721048e-03, -7.1768072469e-03, -1.6677726022e-02, -2.1586715398e-02, -1.9711280629e-02, -1.0852652222e-02, 2.9012561563e-03, 1.7580897576e-02, 2.8381452155e-02, 3.1091520911e-02, 2.3506049519e-02, 6.3958307363e-03, -1.6297939669e-02, -3.8174463499e-02, -5.1866896279e-02, -5.0962348733e-02, -3.1846606408e-02, 5.0389373232e-03, 5.4907534911e-02, 1.0943879561e-01, 1.5853398221e-01, 1.9259818989e-01, 2.0478010513e-01, 1.9259818989e-01, 1.5853398221e-01, 1.0943879561e-01, 5.4907534911e-02, 5.0389373232e-03, -3.1846606408e-02, -5.0962348733e-02, -5.1866896279e-02, -3.8174463499e-02, -1.6297939669e-02, 6.3958307363e-03, 2.3506049519e-02, 3.1091520911e-02, 2.8381452155e-02, 1.7580897576e-02, 2.9012561563e-03, -1.0852652222e-02, -1.9711280629e-02, -2.1586715398e-02, -1.6677726022e-02, -7.1768072469e-03, 3.5738721048e-03, 1.2184272007e-02, 1.6231860270e-02, 1.4899387766e-02, 9.0780941430e-03, 9.4980454205e-04, -6.7847762229e-03, -1.1771468561e-02, -1.2693294804e-02, -9.5908218100e-03, -3.7430904239e-03, 2.8215289899e-03, 8.0075913727e-03, 1.0304733302e-02, 9.2116081137e-03, 5.3174655311e-03, 4.0504695980e-05, -4.8720251529e-03, -7.9106390313e-03, -8.2569924426e-03, -5.9908381328e-03, -2.0030177737e-03, 2.3385037355e-03, 5.6488257898e-03, 6.9604662490e-03, 5.9979433577e-03, 3.2173803305e-03, -3.8565799356e-04, -3.6245610468e-03, -5.5067729307e-03, -5.5323829037e-03, -3.8181942717e-03, -1.0198178937e-03, 1.9103978174e-03, 4.0426404274e-03, 4.7605559337e-03, 3.9341201552e-03, 1.9278490532e-03, -5.4728612220e-04, -2.6811344710e-03, -3.8262174170e-03, -3.6905740791e-03, -2.4053977998e-03, -4.5459597422e-04, 1.5020813220e-03, 2.8491878898e-03, 3.2064623625e-03, 2.5321379468e-03, 1.1121209355e-03, -5.5353327163e-04, -1.9236804537e-03, -2.5896898166e-03, -2.3946074558e-03, -1.4640955099e-03, -1.4578448117e-04, 1.1170156172e-03, 1.9323656242e-03, 2.0793590882e-03, 1.5645443794e-03, 6.0205742619e-04, -4.7033833337e-04, -1.3076663513e-03, -1.6671073846e-03, -1.4761811173e-03, -8.4142966492e-04, 2.7737342414e-07, 7.6758402569e-04, 1.2272322070e-03, 1.2633824175e-03, 9.0363849988e-04, 2.9729829935e-04, -3.4298680990e-04, -8.1424765891e-04, -9.8629867812e-04, -8.3570979460e-04, -4.4257906414e-04, 4.5258358757e-05, 4.6592713429e-04, 6.9612599813e-04, 6.8590911345e-04, 4.6633925499e-04, 1.3045184710e-04, -2.0342762459e-04, -4.3220955008e-04, -4.9886785744e-04, -4.0471101887e-04, -2.0133116207e-04, 3.2644505134e-05, 2.2046888593e-04, 3.1160952577e-04, 2.9406336570e-04, 1.9219801126e-04, 5.2880144342e-05, -7.3723222352e-05, -1.5132051136e-04, -1.6702097766e-04, -1.3107017988e-04, -6.8459660036e-05, -6.7874565391e-06, 3.4495688585e-05, 4.9573991470e-05, 4.5182821672e-05, 3.4425412471e-05, 2.8850898049e-05, 3.2499933259e-05, 4.0421677825e-05, 4.2016087646e-05, 2.7392441069e-05, -6.3555110073e-06, -5.1981141056e-05, -9.3676570509e-05, -1.1300386613e-04, -9.6827810123e-05, -4.3936548271e-05, 3.2592474737e-05, 1.0863530804e-04, 1.5703069703e-04, 1.5756235637e-04, 1.0518393539e-04, 1.3223467640e-05, -8.9963237964e-05, -1.7004225236e-04, -1.9845476965e-04, -1.6275453558e-04, -7.1759757623e-05, 4.6523331080e-05, 1.5373856266e-04, 2.1390660336e-04, 2.0572509741e-04, 1.3017577907e-04, 1.0716214384e-05, -1.1415035601e-04, -2.0351432116e-04, -2.2768183234e-04, -1.7817793102e-04, -7.0726777909e-05, 5.9831203220e-05, 1.7100416652e-04, 2.2666418994e-04, 2.0893139699e-04, 1.2397675727e-04, -1.5101419224e-07, -1.2289402382e-04, -2.0458062132e-04, -2.1937624177e-04, -1.6352298110e-04, -5.6222882892e-05, 6.7005785027e-05, 1.6618260399e-04, 2.0994002924e-04, 1.8551074068e-04, 1.0242917673e-04, -1.1111785679e-05, -1.1787316761e-04, -1.8385675841e-04, -1.8918857601e-04, -1.3409848281e-04, -3.8203309458e-05, 6.6457824879e-05, 1.4616599009e-04, 1.7642744971e-04, 1.4950179648e-04, 7.6242050704e-05, -1.8128764758e-05, -1.0269720775e-04, -1.5100771436e-04, -1.4934104286e-04, -1.0053359641e-04, -2.2306275728e-05, 5.9105543949e-05, 1.1774721572e-04, 1.3621687768e-04, 1.1077980801e-04, 5.1842263438e-05, -2.0124688423e-05, -8.1658719488e-05, -1.1394262823e-04, -1.0852240285e-04, -6.9383750458e-05, -1.0935391065e-05, 4.7209254540e-05, 8.6784841751e-05, 9.6580616528e-05, 7.5529429710e-05, 3.2362851966e-05, -1.7827740761e-05, -5.8813990893e-05, -7.8444696389e-05, -7.2187135903e-05, -4.3987115894e-05, -4.3727841506e-06, 3.3383490018e-05, 5.7670458115e-05, 6.2061100756e-05, 4.6902107727e-05, 1.8623490804e-05, -1.2818473965e-05, -3.7388549018e-05, -4.8132991516e-05, -4.3072443236e-05, -2.5341999448e-05, -1.7005409523e-06, 1.9956820947e-05, 3.3190865626e-05, 3.4877895713e-05, 2.5820777277e-05, 1.0051135135e-05, -6.8093663060e-06, -1.9497674077e-05, -2.4708140103e-05, -2.1871564461e-05, -1.2966644463e-05, -1.5488302566e-06, 8.5865507701e-06, 1.4624666152e-05, 1.5455920723e-05, 1.1742225476e-05, 5.4040281514e-06, -1.2105987638e-06, -6.1462001935e-06, -8.3764326573e-06, -7.9261174173e-06, -5.6151292979e-06, -2.5887090163e-06, 1.5284471504e-07, 2.0504996242e-06, 3.0329617641e-06, 3.3505665573e-06, 3.3152620119e-06, 3.0863715053e-06, 2.6007005635e-06, 1.6657000897e-06, 1.5304131717e-07, -1.8177664888e-06, -3.8111480273e-06, -5.1743746584e-06, -5.2771879357e-06, -3.7970209232e-06, -9.2519518420e-07, 2.6074563892e-06, 5.7195376433e-06, 7.3308520516e-06, 6.7553186521e-06, 3.9877755478e-06, -2.3216577300e-07, -4.6192713319e-06, -7.7493817632e-06, -8.5392432322e-06, -6.6324875594e-06, -2.5517907362e-06, 2.4445858312e-06, 6.7614694683e-06, 8.9901647048e-06, 8.3801851737e-06, 5.0979536375e-06, 1.8217550581e-07, -4.7917163972e-06, -8.2268354832e-06, -9.0277243520e-06, -6.9564940688e-06, -2.7046697321e-06, 2.3408079704e-06, 6.5567645209e-06, 8.6136867262e-06, 7.9008498602e-06, 4.7090628686e-06, 1.1626773176e-07, -4.3796369526e-06, -7.3543987654e-06, -7.9130606737e-06, -5.9605420071e-06, -2.2051754159e-06, 2.0968587868e-06, 5.5640850802e-06, 7.1362377761e-06, 6.3994942325e-06, 3.6905215070e-06, -4.4603515125e-08, -3.5801046005e-06, -5.8139546172e-06, -6.1118513367e-06, -4.4843071471e-06, -1.5487428351e-06, 1.6997409781e-06, 4.2249763239e-06, 5.2799799527e-06, 4.6257089238e-06, 2.5751940256e-06, -1.4025014667e-07, -2.6288424402e-06, -4.1300403642e-06, -4.2450709099e-06, -3.0371590435e-06, -9.7868476333e-07, 1.2270585108e-06, 2.8838382349e-06, 3.5203155568e-06, 3.0202691103e-06, 1.6307876012e-06, -1.4449612556e-07, -1.7240919308e-06, -2.6368887506e-06, -2.6597204012e-06, -1.8652140243e-06, -5.7268564088e-07, 7.7380244447e-07, 1.7552123092e-06, 2.1054324474e-06, 1.7791644058e-06, 9.4424053349e-07, -9.1803601172e-08, -9.9129109401e-07, -1.4940634948e-06, -1.4896978510e-06, -1.0354128881e-06, -3.1991371086e-07, 4.0957853952e-07, 9.3018257513e-07, 1.1090895675e-06, 9.3364621512e-07, 5.0063327475e-07, -2.6981442896e-08, -4.7832916024e-07, -7.2792645896e-07, -7.2802669830e-07, -5.1272445024e-07, -1.7632038325e-07, 1.6381629332e-07, 4.0620040085e-07, 4.9366408311e-07, 4.2400013810e-07, 2.4218019730e-07, 1.9373805322e-08, -1.7267928231e-07, -2.8328423750e-07, -2.9438682451e-07, -2.2027045215e-07, -9.7515708891e-08, 2.9948747913e-08, 1.2520716088e-07, 1.6783322885e-07, 1.5653344067e-07, 1.0553097155e-07, 3.7107600426e-08, -2.6584466614e-08, -6.9781196307e-08, -8.5988254939e-08, -7.7444947193e-08, -5.2218186890e-08, -2.0449868854e-08, 8.8709780392e-09, 2.9810086399e-08, 3.9941387186e-08, 3.9743046382e-08, 3.1533102468e-08, 1.8453365232e-08, 3.7552961640e-09, -9.6168631043e-09, -1.9291397469e-08, -2.3717263238e-08, -2.2415579506e-08, -1.6132735183e-08, -6.7475980529e-09, 3.1508923780e-09}
  COEFFICIENT_WIDTH 24
  QUANTIZATION Quantize_Only
  BESTPRECISION true
  FILTER_TYPE Decimation
  RATE_CHANGE_TYPE Fixed_Fractional
  INTERPOLATION_RATE 2
  DECIMATION_RATE 5
  NUMBER_CHANNELS 10
  NUMBER_PATHS 1
  SAMPLE_FREQUENCY 0.96
  CLOCK_FREQUENCY 125
  OUTPUT_ROUNDING_MODE Convergent_Rounding_to_Even
  OUTPUT_WIDTH 26
  HAS_ARESETN true
} {
  S_AXIS_DATA subset_0/M_AXIS
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create axis_dwidth_converter
cell xilinx.com:ip:axis_dwidth_converter conv_1 {
  S_TDATA_NUM_BYTES.VALUE_SRC USER
  S_TDATA_NUM_BYTES 4
  M_TDATA_NUM_BYTES 40
} {
  S_AXIS fir_1/M_AXIS_DATA
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

# Create axis_broadcaster
cell xilinx.com:ip:axis_broadcaster bcast_0 {
  S_TDATA_NUM_BYTES.VALUE_SRC USER
  M_TDATA_NUM_BYTES.VALUE_SRC USER
  S_TDATA_NUM_BYTES 40
  M_TDATA_NUM_BYTES 8
  NUM_MI 5
  M00_TDATA_REMAP {tdata[23:16],tdata[39:32],tdata[47:40],tdata[55:48],16'b0000000000000000,tdata[7:0],tdata[15:8]}
  M01_TDATA_REMAP {tdata[87:80],tdata[103:96],tdata[111:104],tdata[119:112],16'b0000000000000000,tdata[71:64],tdata[79:72]}
  M02_TDATA_REMAP {tdata[151:144],tdata[167:160],tdata[175:168],tdata[183:176],16'b0000000000000000,tdata[135:128],tdata[143:136]}
  M03_TDATA_REMAP {tdata[215:208],tdata[231:224],tdata[239:232],tdata[247:240],16'b0000000000000000,tdata[199:192],tdata[207:200]}
  M04_TDATA_REMAP {tdata[279:272],tdata[295:288],tdata[303:296],tdata[311:304],16'b0000000000000000,tdata[263:256],tdata[271:264]}
} {
  S_AXIS conv_1/M_AXIS
  aclk /pll_0/clk_out1
  aresetn /rst_0/peripheral_aresetn
}

for {set i 0} {$i <= 4} {incr i} {

  # Create fifo_generator
  cell xilinx.com:ip:fifo_generator fifo_generator_$i {
    PERFORMANCE_OPTIONS First_Word_Fall_Through
    INPUT_DATA_WIDTH 64
    INPUT_DEPTH 1024
    OUTPUT_DATA_WIDTH 32
    OUTPUT_DEPTH 2048
    READ_DATA_COUNT true
    READ_DATA_COUNT_WIDTH 12
  } {
    clk /pll_0/clk_out1
    srst slice_0/dout
  }

  # Create axis_fifo
  cell pavel-demin:user:axis_fifo fifo_$i {
    S_AXIS_TDATA_WIDTH 64
    M_AXIS_TDATA_WIDTH 32
  } {
    S_AXIS bcast_0/M0${i}_AXIS
    FIFO_READ fifo_generator_$i/FIFO_READ
    FIFO_WRITE fifo_generator_$i/FIFO_WRITE
    aclk /pll_0/clk_out1
  }

  # Create axi_axis_reader
  cell pavel-demin:user:axi_axis_reader reader_$i {
    AXI_DATA_WIDTH 32
  } {
    S_AXIS fifo_$i/M_AXIS
    aclk /pll_0/clk_out1
    aresetn /rst_0/peripheral_aresetn
  }

}
